package top.jerryyan.RN.A.FitFullScreen;

import android.os.Build;
import android.provider.Settings;

import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;

import java.util.HashMap;
import java.util.Map;

public class FitModule extends ReactContextBaseJavaModule {
    private final ReactApplicationContext reactContext;
    private final String MANUFACTURER = Build.MANUFACTURER;

    public FitModule(ReactApplicationContext reactContext) {
        super(reactContext);
        this.reactContext = reactContext;
    }

    @Override
    public String getName() {
        return "FitFullScreen";
    }

    @Override
    public Map<String, Object> getConstants(){
        final Map<String, Object> constants = new HashMap<>();
        constants.put("MANUFACTURER", MANUFACTURER);
        return constants;
    }

    private boolean _isXiaoMiFullScreen(){
        return Settings.Global.getInt(reactContext.getContentResolver(), "force_fsg_nav_bar", 0) != 0;
    }

    private boolean _isHuaWeiFullScreen(){
        try {
            reactContext.getClassLoader().loadClass("com.huawei.android.util.HwNotchSizeUtil");
            return true;
        } catch (ClassNotFoundException e) {
            return false;
        }
    }

    @ReactMethod
    public void checkFullScreen(Promise promise){
        if ("xiaomi".equalsIgnoreCase(MANUFACTURER)) {
            promise.resolve(_isXiaoMiFullScreen());
        }
        promise.reject("E");
    }
}
